-- 创建
CREATE MATERIALIZED VIEW meter_analyze_hour
ENGINE = AggregatingMergeTree() PARTITION BY toYYYYMM(time) ORDER BY (time, attr_id)
AS SELECT
    toStartOfHour(time) as time
       ,attr_id
       ,countState(1) as count
       ,sumState(value) as sum
       ,avgState(value) as  avg
       ,maxState(value) as max
       ,minState(value) as min
FROM meter_data
GROUP BY time,attr_id;

-- 插入数据
insert into meter_data values(now(),2,77);

-- 查询
select time,attr_id,sumMerge(sum),countMerge(count),avgMerge(avg),maxMerge(max) as max,minMerge(min) as min,max-min
from meter_analyze_hour
GROUP BY time,attr_id;