SELECT
    event_time,
    query_log.query,
    user,
    query_id AS query,
    read_rows,
    read_bytes,
    result_rows,
    result_bytes,
    memory_usage,
    exception,
       query_duration_ms
FROM system.query_log
WHERE  query_duration_ms > 50 AND (is_initial_query = 1) AND (query NOT LIKE 'INSERT INTO%')
ORDER BY query_duration_ms desc
LIMIT 100
